<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  name: 'NavBanner',
  props: {
    currentLocale: {
      required: true,
      default: '',
      type: String,
    },
  },
  data() {
    return {
      content: null,
    };
  },
  async fetch() {
    const content = (await this.$content(
      `shared/${this.currentLocale}/nav-banner`,
    ).fetch()) as any;
    this.content = content;
  },
});
</script>

<template>
  <div class="banner">
    <div v-if="content.mobile" class="mobile">
      <a
        class="pill"
        :href="content.url"
        :data-ga-name="content.data_ga_name"
        :data-ga-location="content.data_ga_location"
      >
        <div class="pill-content">
          <img src="/nuxt-images/solutions/ai/icons/eyebrow-two.svg" alt="" />
          <SlpTypography variant="body3-bold" tag="span">
            {{ content.mobile.title }}
          </SlpTypography>
          <SlpIcon variant="product" name="arrow-right" />
        </div>
      </a>
    </div>

    <a
      v-if="content"
      :href="content.url"
      :data-ga-name="content.data_ga_name"
      :data-ga-location="content.data_ga_location"
      class="desktop"
    >
      <div class="wrapper">
        <img
          preload
          class="slp-ml-24"
          src="/nuxt-images/banner/gitlab-duo-amazon-q.svg"
          alt=""
        />
        <SlpButton variant="tertiary" class="cta">
          {{ content.title }}
          <SlpIcon
            class="slp-ml-8 arrow-icon"
            variant="product"
            name="arrow-right"
        /></SlpButton>
      </div>
    </a>
  </div>
</template>

<style lang="scss" scoped>
.banner {
  .mobile,
  .desktop {
    display: none;
  }

  .mobile {
    @media (max-width: $breakpoint-md) {
      display: block;
      padding: 9px;

      .pill {
        display: block;
        width: 100%;
        position: relative;
        padding: 8px 12px;
        color: $color-text-300;
        font-size: 14px;
        text-decoration: none;
        --background-gradient: linear-gradient(
          135deg,
          #f7a20f,
          #a989f5,
          #962eff,
          #0099ff
        );
        &:before {
          content: '';
          background: var(--background-gradient) border-box;
          position: absolute;
          top: 0;
          right: 0;
          bottom: 0;
          left: 0;
          border-radius: 70px;
          border: 2px solid transparent;
          mask:
            linear-gradient(#fff 0 0) padding-box,
            linear-gradient(#fff 0 0);
          -webkit-mask:
            linear-gradient(#fff 0 0) padding-box,
            linear-gradient(#fff 0 0);
          -webkit-mask-composite: xor;
          mask-composite: exclude;
        }

        .pill-content {
          display: flex;
          align-items: center;
          justify-content: center;
          position: relative;
          z-index: 1;

          img {
            width: 16px;
            height: 16px;
            margin-right: 8px;
          }

          .slp-icon {
            margin-left: $spacing-16;
            transition: transform 0.2s ease-in-out;
          }
        }

        &:hover .slp-icon {
          transform: translateX(8px);
        }
      }
    }
  }

  .desktop {
    @media (min-width: $breakpoint-md + 1) {
      display: block;
      .wrapper {
        background-color: #171321;
        display: flex;
        align-items: center;
        justify-content: center;
        // Graphics overflow horizontally and some of its children have a fixed width
        overflow: hidden;
        width: 100%;

        @media (min-width: 835px) {
          height: 52px;
        }
        .cta {
          color: $color-text-50;
          font-size: 16px;
          text-decoration: underline;
          padding: 16px;
          font-weight: 400;
          background: transparent;
        }
        &_text {
          color: $color-text-50;
          padding: $spacing-16 0;
        }

        &_image {
          margin-right: $spacing-8;
        }

        &:hover .slp-btn-tertiary .slp-icon {
          transform: translateX(8px);
        }
      }
    }
  }
}
</style>
